import random
import time

#Block DataBase 
class block_Base:
  def __init__(self):
    def get_all_subclasses(cls):
      all_subclasses = []
      for subclass in cls.__subclasses__():
        all_subclasses.append(subclass.__name__)
        all_subclasses.extend(get_all_subclasses(subclass))
      return all_subclasses  
    
    self.database=get_all_subclasses(Block)
    #List of Blocks that exist.

  def _state_check(id_num):
    if str(id_num).startswith("1"):
      return("Solid")
    elif str(id_num).startswith("2"):
      return("Air")
    elif str(id_num).startswith("3"):
      return("Liquid")
    else:
      return("Unknown")
  
  

#Computer Engine
class SpacialEngine(block_Base):
  def __init__(self,leng,mode=None):
    x=[]
    y=[]
    z=[]
    for a in range(leng):
      for b in range(leng):
        for c in range(leng):
          if mode==None:
            y.append(Block(None,None))
          elif mode==1:
            pass
          elif mode==2:
            pass
        x.append(y)
      z.append(x)
      self.space=z

    self.id_numBase={}
    for i in self.database:
      for a in i:
        for b in a:
          self.id_numBase[a.name]=a.ret_id
    print(self.space)
    print(self.id_numBase)
    
  def fetch_block(self,x1,y1,z1):
    return(self.space[z1][x1][y1])
  
  def replace_block(self,z,x,y,block_data):
    pos=self.space[z][x][y].index()
    self.space.pop(self.space[z][x][y])
    self.space.insert(pos,block_info)
  
  def _exist_check(id_num):
    if id_num=="":
      pass

  def AllBlockAnimate(self):
    for i in self.id_numBase:
      pass

  
  def RunLoop(self):
    while 1:
      for block1 in self.space:
        for block2 in block1:
          for block3 in block2:
            state=block3._state_check(block.serial_num)
            if state=="Solid":
              continue
            elif state=="Liquid":
              continue
            elif state=="Air":
              continue
            else:
              raise SyntaxError("Block Data Illegal")
            block3.update_tasks()
  
  



      
      
        

#Block Classes//
class Block(block_Base):
  def __init__(self,name,block_data):
    self.data={"data":None,"Name":name,"State":block_Base._state_check(block_data)}
    self.name=name

  def state(block_id):
    return(_state_check(block_id))
  
  def break_self(self):
    del(self)

#Block Types
#Create Update Tasks
class Air(Block):
  def __init__(self):
    self.block_id=int("1"+str(random.randint(11111,99999)))

  def ret_id(self):
    return(self.block_id)

class Solid(Block):
  def __init__(self):
    self.block_id=int("2"+str(random.randint(11111,99999)))

  def ret_id(self):
    return(self.block_id)

class Liquid(Block):
  def __init__(self):
    self.block_id=int("3"+str(random.randint(11111,99999)))
  
  def ret_id(self):
    return(self.block_id)

#Blocks in General
class Dirt(Solid):
  def __init__(self):
    name=self.__class__.__name__
    print(name)
    a=Solid()
    self.serial_num=a.ret_id()
    print(self.serial_num)
    print(dir(self))
    time.sleep(1)

class Cobblestone(Solid): pass

class Cobweb(Air): pass

class Diamond(Solid): pass







